Index: src/main/java/com/wediscussmovies/project/model/Reply.java
===================================================================
--- src/main/java/com/wediscussmovies/project/model/Reply.java	(revision 2d57cad1a18953bc47becb4f96114a908ecbf03d)
+++ src/main/java/com/wediscussmovies/project/model/Reply.java	(revision 7fafeade7bf35835297971768f9dc93f768c1ff0)
@@ -1,114 +1,51 @@
 package com.wediscussmovies.project.model;
+
+import lombok.Data;
 
 import javax.persistence.*;
 import java.sql.Date;
+import java.util.Optional;
 
 @Entity
 @Table(name = "replies", schema = "project", catalog = "db_202122z_va_prj_wediscussmovies")
 @IdClass(RepliesEntityPK.class)
+@Data
 public class Reply {
     @Id
-    @Column(name = "discussion_id",insertable = false, updatable = false)
-    private int discussionId;
+    @Column(name = "discussion_id")
+    private Long discussionId;
+
     @GeneratedValue(strategy = GenerationType.IDENTITY)
     @Id
     @Column(name = "reply_id")
-    private int replyId;
-    @Basic
-    @Column(name = "text")
+    private Long replyId;
+
     private String text;
-    @Basic
-    @Column(name = "date")
+
     private Date date;
-    @Basic
-    @Column(name = "user_id")
-    private int userId;
+
     @ManyToOne
     @JoinColumn(name = "discussion_id", referencedColumnName = "discussion_id", nullable = false,insertable = false, updatable = false)
-    private Discussion discussionsByDiscussionId;
+    private Discussion discussion;
+
     @ManyToOne
-    @JoinColumn(name = "user_id", referencedColumnName = "user_id", nullable = false,insertable = false, updatable = false)
-    private User usersByUserId;
+    @JoinColumn(name = "user_id")
+    private User user;
 
-    public int getDiscussionId() {
-        return discussionId;
+
+
+
+    public Reply(Discussion discussion, User user, Date date, String text) {
+        this.discussion = discussion;
+        this.user = user;
+        this.date = date;
+        this.text = text;
+
     }
 
-    public void setDiscussionId(int discussionId) {
-        this.discussionId = discussionId;
+    public Reply() {
+
     }
 
-    public int getReplyId() {
-        return replyId;
-    }
 
-    public void setReplyId(int replyId) {
-        this.replyId = replyId;
-    }
-
-    public String getText() {
-        return text;
-    }
-
-    public void setText(String text) {
-        this.text = text;
-    }
-
-    public Date getDate() {
-        return date;
-    }
-
-    public void setDate(Date date) {
-        this.date = date;
-    }
-
-    public int getUserId() {
-        return userId;
-    }
-
-    public void setUserId(int userId) {
-        this.userId = userId;
-    }
-
-    @Override
-    public boolean equals(Object o) {
-        if (this == o) return true;
-        if (o == null || getClass() != o.getClass()) return false;
-
-        Reply that = (Reply) o;
-
-        if (discussionId != that.discussionId) return false;
-        if (replyId != that.replyId) return false;
-        if (userId != that.userId) return false;
-        if (text != null ? !text.equals(that.text) : that.text != null) return false;
-        if (date != null ? !date.equals(that.date) : that.date != null) return false;
-
-        return true;
-    }
-
-    @Override
-    public int hashCode() {
-        int result = discussionId;
-        result = 31 * result + replyId;
-        result = 31 * result + (text != null ? text.hashCode() : 0);
-        result = 31 * result + (date != null ? date.hashCode() : 0);
-        result = 31 * result + userId;
-        return result;
-    }
-
-    public Discussion getDiscussionsByDiscussionId() {
-        return discussionsByDiscussionId;
-    }
-
-    public void setDiscussionsByDiscussionId(Discussion discussionsByDiscussionId) {
-        this.discussionsByDiscussionId = discussionsByDiscussionId;
-    }
-
-    public User getUsersByUserId() {
-        return usersByUserId;
-    }
-
-    public void setUsersByUserId(User usersByUserId) {
-        this.usersByUserId = usersByUserId;
-    }
 }
Index: src/main/java/com/wediscussmovies/project/model/User.java
===================================================================
--- src/main/java/com/wediscussmovies/project/model/User.java	(revision 2d57cad1a18953bc47becb4f96114a908ecbf03d)
+++ src/main/java/com/wediscussmovies/project/model/User.java	(revision 7fafeade7bf35835297971768f9dc93f768c1ff0)
@@ -3,4 +3,5 @@
 import javax.persistence.*;
 import java.util.Collection;
+import java.util.List;
 
 @Entity
@@ -10,155 +11,31 @@
     @Id
     @Column(name = "user_id")
-    private int userId;
-    @Basic
-    @Column(name = "username")
+    private Long userId;
+
     private String username;
-    @Basic
-    @Column(name = "name")
+
     private String name;
-    @Basic
-    @Column(name = "surname")
+
     private String surname;
-    @Basic
-    @Column(name = "email")
+
     private String email;
-    @Basic
-    @Column(name = "password")
+
     private String password;
-    @OneToMany(mappedBy = "usersByUserId")
-    private Collection<Discussion> discussionsByUserId;
-    @OneToMany(mappedBy = "usersByUserId")
-    private Collection<MovieLikesEntity> movieLikesByUserId;
-    @OneToMany(mappedBy = "usersByUserId")
-    private Collection<MovieRatesEntity> movieRatesByUserId;
-    @OneToMany(mappedBy = "usersByUserId")
-    private Collection<PersonRatesEntity> personRatesByUserId;
-    @OneToMany(mappedBy = "usersByUserId")
-    private Collection<Reply> repliesByUserId;
-    @OneToMany(mappedBy = "usersByUserId")
-    private Collection<UserGenresEntity> userGenresByUserId;
 
-    public int getUserId() {
-        return userId;
-    }
+    @ManyToMany
+    private List<Movie> movies;
 
-    public void setUserId(int userId) {
-        this.userId = userId;
-    }
 
-    public String getUsername() {
-        return username;
-    }
 
-    public void setUsername(String username) {
+
+    public User(String username, String name, String surname, String email, String password) {
         this.username = username;
-    }
-
-    public String getName() {
-        return name;
-    }
-
-    public void setName(String name) {
         this.name = name;
-    }
-
-    public String getSurname() {
-        return surname;
-    }
-
-    public void setSurname(String surname) {
         this.surname = surname;
-    }
-
-    public String getEmail() {
-        return email;
-    }
-
-    public void setEmail(String email) {
         this.email = email;
-    }
-
-    public String getPassword() {
-        return password;
-    }
-
-    public void setPassword(String password) {
         this.password = password;
     }
 
-    @Override
-    public boolean equals(Object o) {
-        if (this == o) return true;
-        if (o == null || getClass() != o.getClass()) return false;
-
-        User that = (User) o;
-
-        if (userId != that.userId) return false;
-        if (username != null ? !username.equals(that.username) : that.username != null) return false;
-        if (name != null ? !name.equals(that.name) : that.name != null) return false;
-        if (surname != null ? !surname.equals(that.surname) : that.surname != null) return false;
-        if (email != null ? !email.equals(that.email) : that.email != null) return false;
-        if (password != null ? !password.equals(that.password) : that.password != null) return false;
-
-        return true;
-    }
-
-    @Override
-    public int hashCode() {
-        int result = userId;
-        result = 31 * result + (username != null ? username.hashCode() : 0);
-        result = 31 * result + (name != null ? name.hashCode() : 0);
-        result = 31 * result + (surname != null ? surname.hashCode() : 0);
-        result = 31 * result + (email != null ? email.hashCode() : 0);
-        result = 31 * result + (password != null ? password.hashCode() : 0);
-        return result;
-    }
-
-    public Collection<Discussion> getDiscussionsByUserId() {
-        return discussionsByUserId;
-    }
-
-    public void setDiscussionsByUserId(Collection<Discussion> discussionsByUserId) {
-        this.discussionsByUserId = discussionsByUserId;
-    }
-
-    public Collection<MovieLikesEntity> getMovieLikesByUserId() {
-        return movieLikesByUserId;
-    }
-
-    public void setMovieLikesByUserId(Collection<MovieLikesEntity> movieLikesByUserId) {
-        this.movieLikesByUserId = movieLikesByUserId;
-    }
-
-    public Collection<MovieRatesEntity> getMovieRatesByUserId() {
-        return movieRatesByUserId;
-    }
-
-    public void setMovieRatesByUserId(Collection<MovieRatesEntity> movieRatesByUserId) {
-        this.movieRatesByUserId = movieRatesByUserId;
-    }
-
-    public Collection<PersonRatesEntity> getPersonRatesByUserId() {
-        return personRatesByUserId;
-    }
-
-    public void setPersonRatesByUserId(Collection<PersonRatesEntity> personRatesByUserId) {
-        this.personRatesByUserId = personRatesByUserId;
-    }
-
-    public Collection<Reply> getRepliesByUserId() {
-        return repliesByUserId;
-    }
-
-    public void setRepliesByUserId(Collection<Reply> repliesByUserId) {
-        this.repliesByUserId = repliesByUserId;
-    }
-
-    public Collection<UserGenresEntity> getUserGenresByUserId() {
-        return userGenresByUserId;
-    }
-
-    public void setUserGenresByUserId(Collection<UserGenresEntity> userGenresByUserId) {
-        this.userGenresByUserId = userGenresByUserId;
+    public User() {
     }
 }
Index: src/main/java/com/wediscussmovies/project/model/enumerations/DiscussionType.java
===================================================================
--- src/main/java/com/wediscussmovies/project/model/enumerations/DiscussionType.java	(revision 7fafeade7bf35835297971768f9dc93f768c1ff0)
+++ src/main/java/com/wediscussmovies/project/model/enumerations/DiscussionType.java	(revision 7fafeade7bf35835297971768f9dc93f768c1ff0)
@@ -0,0 +1,5 @@
+package com.wediscussmovies.project.model.enumerations;
+
+public enum DiscussionType {
+    M,P
+}
Index: src/main/java/com/wediscussmovies/project/model/enumerations/PersonType.java
===================================================================
--- src/main/java/com/wediscussmovies/project/model/enumerations/PersonType.java	(revision 7fafeade7bf35835297971768f9dc93f768c1ff0)
+++ src/main/java/com/wediscussmovies/project/model/enumerations/PersonType.java	(revision 7fafeade7bf35835297971768f9dc93f768c1ff0)
@@ -0,0 +1,5 @@
+package com.wediscussmovies.project.model.enumerations;
+
+public enum PersonType {
+    A, D
+}
Index: src/main/java/com/wediscussmovies/project/model/exception/InvalidUserCredentialsException.java
===================================================================
--- src/main/java/com/wediscussmovies/project/model/exception/InvalidUserCredentialsException.java	(revision 7fafeade7bf35835297971768f9dc93f768c1ff0)
+++ src/main/java/com/wediscussmovies/project/model/exception/InvalidUserCredentialsException.java	(revision 7fafeade7bf35835297971768f9dc93f768c1ff0)
@@ -0,0 +1,7 @@
+package com.wediscussmovies.project.model.exception;
+
+public class InvalidUserCredentialsException extends RuntimeException{
+    public InvalidUserCredentialsException(String username) {
+        super("The user with the username {" + username +"} cannot be authenticated.");
+    }
+}
Index: src/main/java/com/wediscussmovies/project/model/exception/MovieIdNotFoundException.java
===================================================================
--- src/main/java/com/wediscussmovies/project/model/exception/MovieIdNotFoundException.java	(revision 7fafeade7bf35835297971768f9dc93f768c1ff0)
+++ src/main/java/com/wediscussmovies/project/model/exception/MovieIdNotFoundException.java	(revision 7fafeade7bf35835297971768f9dc93f768c1ff0)
@@ -0,0 +1,7 @@
+package com.wediscussmovies.project.model.exception;
+
+public class MovieIdNotFoundException extends RuntimeException{
+    public MovieIdNotFoundException(Integer id) {
+        super("Movie with id {"+id+"} was not found.");
+    }
+}
Index: src/main/java/com/wediscussmovies/project/model/exception/NotEnoughArgumentsException.java
===================================================================
--- src/main/java/com/wediscussmovies/project/model/exception/NotEnoughArgumentsException.java	(revision 7fafeade7bf35835297971768f9dc93f768c1ff0)
+++ src/main/java/com/wediscussmovies/project/model/exception/NotEnoughArgumentsException.java	(revision 7fafeade7bf35835297971768f9dc93f768c1ff0)
@@ -0,0 +1,4 @@
+package com.wediscussmovies.project.model.exception;
+
+public class NotEnoughArgumentsException {
+}
Index: src/main/java/com/wediscussmovies/project/model/exception/PasswordsDontMatchException.java
===================================================================
--- src/main/java/com/wediscussmovies/project/model/exception/PasswordsDontMatchException.java	(revision 7fafeade7bf35835297971768f9dc93f768c1ff0)
+++ src/main/java/com/wediscussmovies/project/model/exception/PasswordsDontMatchException.java	(revision 7fafeade7bf35835297971768f9dc93f768c1ff0)
@@ -0,0 +1,7 @@
+package com.wediscussmovies.project.model.exception;
+
+public class PasswordsDontMatchException extends RuntimeException{
+    public PasswordsDontMatchException() {
+        super("The passwords you provided did not match.");
+    }
+}
Index: src/main/java/com/wediscussmovies/project/model/exception/UserWithEmailAlreadyExists.java
===================================================================
--- src/main/java/com/wediscussmovies/project/model/exception/UserWithEmailAlreadyExists.java	(revision 7fafeade7bf35835297971768f9dc93f768c1ff0)
+++ src/main/java/com/wediscussmovies/project/model/exception/UserWithEmailAlreadyExists.java	(revision 7fafeade7bf35835297971768f9dc93f768c1ff0)
@@ -0,0 +1,7 @@
+package com.wediscussmovies.project.model.exception;
+
+public class UserWithEmailAlreadyExists extends RuntimeException{
+    public UserWithEmailAlreadyExists(String email) {
+        super("User with the email {" + email +"} is already registered");
+    }
+}
Index: src/main/java/com/wediscussmovies/project/model/exception/UserWithUsernameAlreadyExists.java
===================================================================
--- src/main/java/com/wediscussmovies/project/model/exception/UserWithUsernameAlreadyExists.java	(revision 7fafeade7bf35835297971768f9dc93f768c1ff0)
+++ src/main/java/com/wediscussmovies/project/model/exception/UserWithUsernameAlreadyExists.java	(revision 7fafeade7bf35835297971768f9dc93f768c1ff0)
@@ -0,0 +1,7 @@
+package com.wediscussmovies.project.model.exception;
+
+public class UserWithUsernameAlreadyExists extends RuntimeException{
+    public UserWithUsernameAlreadyExists(String username) {
+        super("User with the username " + username + " is already registered");
+    }
+}
Index: src/main/java/com/wediscussmovies/project/repository/DiscussionRepository.java
===================================================================
--- src/main/java/com/wediscussmovies/project/repository/DiscussionRepository.java	(revision 2d57cad1a18953bc47becb4f96114a908ecbf03d)
+++ src/main/java/com/wediscussmovies/project/repository/DiscussionRepository.java	(revision 7fafeade7bf35835297971768f9dc93f768c1ff0)
@@ -5,5 +5,8 @@
 import org.springframework.stereotype.Repository;
 
+import java.util.List;
+
 @Repository
 public interface DiscussionRepository extends JpaRepository<Discussion, Integer> {
+    public List<Discussion> findAllByTitleLike(String title);
 }
Index: src/main/java/com/wediscussmovies/project/repository/GenreRepository.java
===================================================================
--- src/main/java/com/wediscussmovies/project/repository/GenreRepository.java	(revision 2d57cad1a18953bc47becb4f96114a908ecbf03d)
+++ src/main/java/com/wediscussmovies/project/repository/GenreRepository.java	(revision 7fafeade7bf35835297971768f9dc93f768c1ff0)
@@ -5,5 +5,8 @@
 import org.springframework.stereotype.Repository;
 
+import java.util.List;
+
 @Repository
 public interface GenreRepository extends JpaRepository<Genre, Integer> {
+    public List<Genre> findAllByGenre(String genre_type);
 }
Index: src/main/java/com/wediscussmovies/project/repository/PersonRepository.java
===================================================================
--- src/main/java/com/wediscussmovies/project/repository/PersonRepository.java	(revision 2d57cad1a18953bc47becb4f96114a908ecbf03d)
+++ src/main/java/com/wediscussmovies/project/repository/PersonRepository.java	(revision 7fafeade7bf35835297971768f9dc93f768c1ff0)
@@ -2,8 +2,17 @@
 
 import com.wediscussmovies.project.model.Person;
+import com.wediscussmovies.project.model.enumerations.PersonType;
 import org.springframework.data.jpa.repository.JpaRepository;
+import org.springframework.data.jpa.repository.Query;
 import org.springframework.stereotype.Repository;
+
+import java.util.List;
+import java.util.Optional;
 
 @Repository
 public interface PersonRepository extends JpaRepository<Person, Integer> {
+    public List<Person> findAllByPersonType(PersonType type);
+    public List<Person> findAllByPersonTypeAndNameLike(PersonType type, String name);
+    public List<Person> findAllByPersonTypeAndSurnameLike(PersonType type, String surname);
+    public Optional<Person> findPersonByPerson_idAndPersonType(Integer id, PersonType type);
 }
Index: src/main/java/com/wediscussmovies/project/repository/UserRepository.java
===================================================================
--- src/main/java/com/wediscussmovies/project/repository/UserRepository.java	(revision 2d57cad1a18953bc47becb4f96114a908ecbf03d)
+++ src/main/java/com/wediscussmovies/project/repository/UserRepository.java	(revision 7fafeade7bf35835297971768f9dc93f768c1ff0)
@@ -5,5 +5,12 @@
 import org.springframework.stereotype.Repository;
 
+import java.util.EnumMap;
+import java.util.Optional;
+
 @Repository
 public interface UserRepository extends JpaRepository<User, Integer> {
+    public Optional<User> findByEmailAndPassword(String email, String password);
+    public Optional<User> findByUsernameAndPassword(String email, String password);
+    public Optional<User> findByUsername(String username);
+    public Optional<User> findByEmail(String email);
 }
Index: src/main/java/com/wediscussmovies/project/service/DiscussionService.java
===================================================================
--- src/main/java/com/wediscussmovies/project/service/DiscussionService.java	(revision 2d57cad1a18953bc47becb4f96114a908ecbf03d)
+++ src/main/java/com/wediscussmovies/project/service/DiscussionService.java	(revision 7fafeade7bf35835297971768f9dc93f768c1ff0)
@@ -1,4 +1,13 @@
 package com.wediscussmovies.project.service;
 
+import com.wediscussmovies.project.model.Discussion;
+
+import java.util.List;
+import java.util.Optional;
+
 public interface DiscussionService {
+    List<Discussion> listAll();
+    List<Discussion> listAllByTitle(String title);
+    Optional<Discussion> findById(Integer id);
+    void save(Discussion discussion);
 }
Index: src/main/java/com/wediscussmovies/project/service/GenreService.java
===================================================================
--- src/main/java/com/wediscussmovies/project/service/GenreService.java	(revision 2d57cad1a18953bc47becb4f96114a908ecbf03d)
+++ src/main/java/com/wediscussmovies/project/service/GenreService.java	(revision 7fafeade7bf35835297971768f9dc93f768c1ff0)
@@ -1,4 +1,15 @@
 package com.wediscussmovies.project.service;
 
+import com.wediscussmovies.project.model.Genre;
+import org.springframework.stereotype.Service;
+
+import java.util.List;
+import java.util.Optional;
+
+@Service
 public interface GenreService {
+    public List<Genre> findAll();
+    public Optional<Genre> findById(Integer id);
+    public List<Genre> findAllByType(String genre);
+    public Genre save(String genreName);
 }
Index: src/main/java/com/wediscussmovies/project/service/MovieService.java
===================================================================
--- src/main/java/com/wediscussmovies/project/service/MovieService.java	(revision 2d57cad1a18953bc47becb4f96114a908ecbf03d)
+++ src/main/java/com/wediscussmovies/project/service/MovieService.java	(revision 7fafeade7bf35835297971768f9dc93f768c1ff0)
@@ -4,7 +4,11 @@
 
 import java.util.List;
+import java.util.Optional;
 
 public interface MovieService {
     public List<Movie> listAll();
     public List<Movie> searchByTitle(String title);
+    public Optional<Movie> findById(Long id);
+    public Movie save(Movie movie);
+    public void deleteById(Long id);
 }
Index: src/main/java/com/wediscussmovies/project/service/PersonService.java
===================================================================
--- src/main/java/com/wediscussmovies/project/service/PersonService.java	(revision 2d57cad1a18953bc47becb4f96114a908ecbf03d)
+++ src/main/java/com/wediscussmovies/project/service/PersonService.java	(revision 7fafeade7bf35835297971768f9dc93f768c1ff0)
@@ -1,4 +1,20 @@
 package com.wediscussmovies.project.service;
 
+import com.wediscussmovies.project.model.Person;
+
+import java.util.List;
+import java.util.Optional;
+
 public interface PersonService {
+     List<Person> findAllDirectors();
+     List<Person> findAllActors();
+    Optional<Person> findById(Integer person_id);
+    Optional<Person> findActorById(Integer id);
+    Optional<Person> findDirectorById(Integer id);
+    boolean save(Person person);
+    List<Person> findActorsByNameLike(String name);
+    List<Person> findActorsBySurnameLike(String surname);
+    List<Person> findDirectorsByNameLike(String name);
+    List<Person> findDirectorsBySurnameLike(String surname);
+
 }
Index: src/main/java/com/wediscussmovies/project/service/ReplyService.java
===================================================================
--- src/main/java/com/wediscussmovies/project/service/ReplyService.java	(revision 2d57cad1a18953bc47becb4f96114a908ecbf03d)
+++ src/main/java/com/wediscussmovies/project/service/ReplyService.java	(revision 7fafeade7bf35835297971768f9dc93f768c1ff0)
@@ -1,4 +1,12 @@
 package com.wediscussmovies.project.service;
 
+import com.wediscussmovies.project.model.Reply;
+
+import java.util.Optional;
+
 public interface ReplyService {
+    public Reply save(Reply r);
+    public void delete(Reply r);
+    Optional<Reply> findById(Long id);
+
 }
Index: src/main/java/com/wediscussmovies/project/service/UserService.java
===================================================================
--- src/main/java/com/wediscussmovies/project/service/UserService.java	(revision 2d57cad1a18953bc47becb4f96114a908ecbf03d)
+++ src/main/java/com/wediscussmovies/project/service/UserService.java	(revision 7fafeade7bf35835297971768f9dc93f768c1ff0)
@@ -1,4 +1,11 @@
 package com.wediscussmovies.project.service;
 
+import com.wediscussmovies.project.model.User;
+
+import javax.servlet.http.HttpServletRequest;
+import java.util.Optional;
+
 public interface UserService {
+    public Optional<User> login(String email, String password);
+    public Optional<User> register(HttpServletRequest request, String email, String password, String confirmPassword, String username, String name, String surname);
 }
Index: src/main/java/com/wediscussmovies/project/service/impl/DiscussionServiceImpl.java
===================================================================
--- src/main/java/com/wediscussmovies/project/service/impl/DiscussionServiceImpl.java	(revision 7fafeade7bf35835297971768f9dc93f768c1ff0)
+++ src/main/java/com/wediscussmovies/project/service/impl/DiscussionServiceImpl.java	(revision 7fafeade7bf35835297971768f9dc93f768c1ff0)
@@ -0,0 +1,38 @@
+package com.wediscussmovies.project.service.impl;
+
+import com.wediscussmovies.project.model.Discussion;
+import com.wediscussmovies.project.repository.DiscussionRepository;
+import com.wediscussmovies.project.service.DiscussionService;
+import org.springframework.stereotype.Service;
+
+import java.util.List;
+import java.util.Optional;
+
+@Service
+public class DiscussionServiceImpl implements DiscussionService {
+    private final DiscussionRepository discussionRepository;
+
+    public DiscussionServiceImpl(DiscussionRepository discussionRepository) {
+        this.discussionRepository = discussionRepository;
+    }
+
+    @Override
+    public List<Discussion> listAll() {
+        return discussionRepository.findAll();
+    }
+
+    @Override
+    public void save(Discussion discussion) {
+        discussionRepository.save(discussion);
+    }
+
+    @Override
+    public Optional<Discussion> findById(Integer id) {
+        return discussionRepository.findById(id);
+    }
+
+    @Override
+    public List<Discussion> listAllByTitle(String title) {
+        return discussionRepository.findAllByTitleLike("%"+title+"%");
+    }
+}
Index: src/main/java/com/wediscussmovies/project/service/impl/GenreServiceImpl.java
===================================================================
--- src/main/java/com/wediscussmovies/project/service/impl/GenreServiceImpl.java	(revision 7fafeade7bf35835297971768f9dc93f768c1ff0)
+++ src/main/java/com/wediscussmovies/project/service/impl/GenreServiceImpl.java	(revision 7fafeade7bf35835297971768f9dc93f768c1ff0)
@@ -0,0 +1,39 @@
+package com.wediscussmovies.project.service.impl;
+
+import com.wediscussmovies.project.model.Genre;
+import com.wediscussmovies.project.repository.GenreRepository;
+import com.wediscussmovies.project.service.GenreService;
+import org.springframework.stereotype.Service;
+
+import java.util.List;
+import java.util.Optional;
+
+@Service
+public class GenreServiceImpl implements GenreService {
+    private final GenreRepository genreRepository;
+
+    public GenreServiceImpl(GenreRepository genreRepository) {
+        this.genreRepository = genreRepository;
+    }
+
+    @Override
+    public Optional<Genre> findById(Integer id) {
+        return genreRepository.findById(id);
+    }
+
+    @Override
+    public List<Genre> findAllByType(String genre) {
+        return genreRepository.findAllByGenre(genre);
+    }
+
+    @Override
+    public Genre save(String genreName) {
+        Genre genre = new Genre(genreName);
+        return genreRepository.save(genre);
+    }
+
+    @Override
+    public List<Genre> findAll() {
+        return genreRepository.findAll();
+    }
+}
Index: src/main/java/com/wediscussmovies/project/service/impl/MovieServiceImpl.java
===================================================================
--- src/main/java/com/wediscussmovies/project/service/impl/MovieServiceImpl.java	(revision 2d57cad1a18953bc47becb4f96114a908ecbf03d)
+++ src/main/java/com/wediscussmovies/project/service/impl/MovieServiceImpl.java	(revision 7fafeade7bf35835297971768f9dc93f768c1ff0)
@@ -7,4 +7,5 @@
 
 import java.util.List;
+import java.util.Optional;
 
 @Service
@@ -22,6 +23,23 @@
 
     @Override
+    public Optional<Movie> findById(Long id) {
+        return movieRepository.findById(1);
+    }
+
+    @Override
+    public Movie save(Movie movie) {
+        return movieRepository.save(movie);
+    }
+
+    @Override
+    public void deleteById(Long id) {
+        movieRepository.deleteById(0);
+    }
+
+    @Override
     public List<Movie> searchByTitle(String title) {
         return movieRepository.findAllByTitleLike("%"+title+"%");
     }
 }
+
+
Index: src/main/java/com/wediscussmovies/project/service/impl/PersonServiceImpl.java
===================================================================
--- src/main/java/com/wediscussmovies/project/service/impl/PersonServiceImpl.java	(revision 7fafeade7bf35835297971768f9dc93f768c1ff0)
+++ src/main/java/com/wediscussmovies/project/service/impl/PersonServiceImpl.java	(revision 7fafeade7bf35835297971768f9dc93f768c1ff0)
@@ -0,0 +1,73 @@
+package com.wediscussmovies.project.service.impl;
+
+import com.wediscussmovies.project.model.Person;
+import com.wediscussmovies.project.model.enumerations.PersonType;
+import com.wediscussmovies.project.repository.PersonRepository;
+import com.wediscussmovies.project.service.PersonService;
+import org.springframework.stereotype.Service;
+
+import java.util.List;
+import java.util.Optional;
+
+@Service
+public class PersonServiceImpl implements PersonService {
+    private final PersonRepository personRepository;
+
+
+    public PersonServiceImpl(PersonRepository personRepository) {
+        this.personRepository = personRepository;
+    }
+
+    @Override
+    public List<Person> findAllDirectors() {
+        return personRepository.findAllByPersonType(PersonType.D);
+    }
+
+    @Override
+    public Optional<Person> findActorById(Integer id) {
+        return personRepository.findPersonByPerson_idAndPersonType(id, PersonType.A);
+    }
+
+    @Override
+    public Optional<Person> findById(Integer person_id) {
+        return personRepository.findById(person_id);
+    }
+
+    @Override
+    public Optional<Person> findDirectorById(Integer id) {
+        return personRepository.findPersonByPerson_idAndPersonType(id, PersonType.D);
+    }
+
+    @Override
+    public List<Person> findAllActors() {
+        return personRepository.findAllByPersonType(PersonType.A);
+    }
+
+    @Override
+    public boolean save(Person person) {
+        Person p = personRepository.save(person);
+        if(p != null)
+            return true;
+        return false;
+    }
+
+    @Override
+    public List<Person> findActorsByNameLike(String name) {
+        return personRepository.findAllByPersonTypeAndNameLike(PersonType.A, name);
+    }
+
+    @Override
+    public List<Person> findActorsBySurnameLike(String surname) {
+        return personRepository.findAllByPersonTypeAndSurnameLike(PersonType.A, surname);
+    }
+
+    @Override
+    public List<Person> findDirectorsByNameLike(String name) {
+        return personRepository.findAllByPersonTypeAndNameLike(PersonType.D, name);
+    }
+
+    @Override
+    public List<Person> findDirectorsBySurnameLike(String surname) {
+        return personRepository.findAllByPersonTypeAndSurnameLike(PersonType.D, surname);
+    }
+}
Index: src/main/java/com/wediscussmovies/project/service/impl/ReplyServiceImpl.java
===================================================================
--- src/main/java/com/wediscussmovies/project/service/impl/ReplyServiceImpl.java	(revision 7fafeade7bf35835297971768f9dc93f768c1ff0)
+++ src/main/java/com/wediscussmovies/project/service/impl/ReplyServiceImpl.java	(revision 7fafeade7bf35835297971768f9dc93f768c1ff0)
@@ -0,0 +1,32 @@
+package com.wediscussmovies.project.service.impl;
+
+import com.wediscussmovies.project.model.Reply;
+import com.wediscussmovies.project.repository.ReplyRepository;
+import com.wediscussmovies.project.service.ReplyService;
+import org.springframework.stereotype.Service;
+
+import java.util.Optional;
+
+@Service
+public class ReplyServiceImpl implements ReplyService {
+    private final ReplyRepository replyRepository;
+
+    public ReplyServiceImpl(ReplyRepository replyRepository) {
+        this.replyRepository = replyRepository;
+    }
+
+    @Override
+    public Optional<Reply> findById(Long id) {
+        return replyRepository.findById(1);
+    }
+
+    @Override
+    public void delete(Reply r) {
+        replyRepository.delete(r);
+    }
+
+    @Override
+    public Reply save(Reply r) {
+        return replyRepository.save(r);
+    }
+}
